stages:
  - build
  - security-scan-sca
  - security-scan
  - scan_reporting

Compile Application:
    image: maven:3.6.0-jdk-8
    stage: build
    script:
      - mvn clean package
    artifacts:
      name: verademo_build
      paths:
        - target/
      expire_in: 5 week
    cache:
      paths:
        - target/
        - .m2/repository


Software Composition Analysis App 3rd party:
    image: maven:3.6.0-jdk-8
    stage: security-scan
    before_script:
        - curl -sL https://deb.nodesource.com/setup_17.x | bash -
        - apt-get update && apt-get -y install nodejs
        - npm install axios
        - npm install mathjs
    script:
        - curl -sSL https://download.sourceclear.com/ci.sh | bash -s scan . --update-advisor --allow-dirty --json scaResults.json --scan-collectors maven 2>&1 | tee sca_output.txt

    after_script:
        - nodejs ./veracode-helper/dependencies_app.js ${PRIVATE_TOKEN} true 38675916

    artifacts:
        reports:
            dependency_scanning: output-sca-vulnerabilitis.json
        paths:
            - sca_output.txt
            - output-sca-vulnerabilitis.json
        when: always
        name: "veracode-SCA-$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"
    allow_failure: true

Software Composition Analysis App 3rd party 2:
    image: maven:3.6.0-jdk-8
    stage: security-scan-sca
    
    script:
        - curl -vk https://platform-backend.analysiscenter.veracode.eu
        - curl https://download.sourceclear.com/
        - curl -sSL https://download.sourceclear.com/ci.sh | bash -s scan . --update-advisor --allow-dirty --scan-collectors maven --debug 2>&1 | tee sca_output.txt

    artifacts:
        reports:
            dependency_scanning: output-sca-vulnerabilitis.json
        paths:
            - sca_output.txt
            - output-sca-vulnerabilitis.json
        when: always
        name: "veracode-SCA-$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"
    allow_failure: true


Pipeline Scan Static Analysis:
    image: veracode/pipeline-scan:latest
    stage: security-scan
    only:
      - feature-123
    except:
      - schedules
    script:
        - java -jar /opt/veracode/pipeline-scan.jar -vid ${VERACODE_API_ID} -vkey ${VERACODE_API_KEY} --request_policy "VeraDemo Policy" 2>&1 | tee pipeline_scan_policy_output.txt
        - java -jar /opt/veracode/pipeline-scan.jar -vid ${VERACODE_API_ID} -vkey ${VERACODE_API_KEY} --file target/verademo.war --issue_details true --gl_issue_generation true --gl_vulnerability_generation true --policy_file VeraDemo_Policy.json -fjf filtered_results.json 2>&1 | tee pipeline_scan_text_output.txt
    artifacts:
        reports: 
            sast: veracode_gitlab_vulnerabilites.json
        paths:
            - results.json
            - filtered_results.json
            - pipeline_scan_text_output.txt
            - pipeline_scan_policy_output.pipeline_scan_text_output
            - veracode_gitlab_vulnerabilites.json
        when: always
        name: "veracode-pipeline-$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"
    allow_failure: true




Sandbox Scan Static Analysis:
    image: veracode/api-wrapper-java
    stage: security-scan
    only:
      - schedules
    script:
      - java -jar /opt/veracode/api-wrapper.jar -vid ${VERACODE_API_ID} -vkey ${VERACODE_API_KEY}
        -action UploadAndScan -appname "GitLab_Verademo_Training" -createprofile true -autoscan true
        -sandboxname "gitlab-feature-branch" -createsandbox true
        -filepath ./target/verademo.war -version "Job ${CI_JOB_ID} in pipeline ${CI_PIPELINE_ID}"
        -scantimeout 15 2>&1 | tee policy_scan_output.txt

    artifacts:
      paths:
          - policy_scan_output.txt
      when: always
      name: "veracode-POLICY-SCAN-$CI_COMMIT_REF_NAME_$CI_COMMIT_SHORT_SHA"
    allow_failure: true



Policy Scan Static Analysis:
    image: veracode/api-wrapper-java
    stage: security-scan
    only:
      - merge_request
    script:
      - java -jar /opt/veracode/api-wrapper.jar -vid ${VERACODE_API_ID} -vkey ${VERACODE_API_KEY}
        -action UploadAndScan -appname "GitLab_Verademo_Training" -createprofile true -autoscan true
        -filepath ./target/verademo.war -version "Job ${CI_JOB_ID} in pipeline ${CI_PIPELINE_ID}"
        -scantimeout 15 2>&1 | tee policy_scan_output.txt

    artifacts:
      paths:
          - policy_scan_output.txt
      when: always
      name: "veracode-POLICY-SCAN-$CI_COMMIT_REF_NAME_$CI_COMMIT_SHORT_SHA"
    allow_failure: true

Generate static analysis report and issues - Sandbox Scan:
    image: node:latest
    stage: scan_reporting
    only:
        - schedules
    before_script:
        - cd veracode-helper
        - npm ci
    script:
        - npm run results-import scan_type=sandbox profile_name=GitLab_Verademo_Training sandbox_name=gitlab-feature-branch gitlab_token=${PRIVATE_TOKEN} gitlab_project=38675916 create_issue=true  
    artifacts:
        reports:
            sast: veracode-helper/output-sast-vulnerabilites.json
        paths: 
            - veracode-helper/output-sast-vulnerabilites.json
        when: always
        name: "veracode-POLICY-SCAN-RESULTS-$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"

Generate static analysis report and issues - Policy Scan:
    image: node:latest
    stage: scan_reporting
    only:
        - merge_request
    except:
      changes:
        - pipeline-basline.json
    before_script:
        - cd veracode-helper
        - npm ci
    script:
        - npm run results-import scan_type=policy profile_name=GitLab_Verademo_Training gitlab_token=${PRIVATE_TOKEN} gitlab_project=38675916 create_issue=true  
    artifacts:
        reports:
            sast: veracode-helper/output-sast-vulnerabilites.json
        paths: 
            - veracode-helper/output-sast-vulnerabilites.json
        when: always
        name: "veracode-POLICY-SCAN-RESULTS-$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA"

   